import getParentNode from "./getParentNode.js";
import getComputedStyle from "./getComputedStyle.js";
import getNodeName from "./getNodeName.js";
import { isHTMLElement } from "./instanceOf.js";
export default function getOverflowParent(node, type) {
  if (type === void 0) {
    type = 'scroll';
  }

  if (['html', 'body', '#document'].includes(getNodeName(node))) {
    return node.ownerDocument.body;
  }

  if (isHTMLElement(node)) {
    // Firefox wants us to check `-x` and `-y` variations as well
    var _getComputedStyle = getComputedStyle(node),
        overflow = _getComputedStyle.overflow,
        overflowX = _getComputedStyle.overflowX,
        overflowY = _getComputedStyle.overflowY;

    var re = type === 'scroll' ? /visible|hidden/ : /visible/;
    var str = overflow + overflowY + overflowX;

    if (str !== '' && !re.test(str)) {
      return node;
    }
  }

  return getOverflowParent(getParentNode(node), type);
}